import { DetailedHTMLProps, HTMLAttributes } from 'react';

interface CursorOptions {
    /** Speed of the component following the cursor. It is not recommended to set it below `0` and above `1` */
    speed?: number;
    /** Optional action that is being invoked when moving the cursor. */
    onMove?: (e: MouseEvent) => void;
}

type EfficientCursorProps = DetailedHTMLProps<HTMLAttributes<HTMLDivElement>, HTMLDivElement> & CursorOptions;
declare const EfficientCursor: ({ children, className, speed, onMove, ...props }: EfficientCursorProps) => JSX.Element;

export { EfficientCursor };
